"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

PPCompiledParser subclass:#PPTokenizingCompiledParser
	instanceVariableNames:'currentTokenValue currentTokenType scanner'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Parsers'
!

!PPTokenizingCompiledParser methodsFor:'tokenizing'!

consume: tokenType
    self halt: 'deprecated'.
    (self perform: tokenType) ifTrue: [ 
        currentTokenType := nil.
        ^ currentTokenValue.
    ].	
    "self error: 'expected: ', tokenType storeString, ' got ', currentTokenType storeString."
    self error.
!

consumeWhitespace
    self shouldBeImplemented 
!

currentTokenType
    currentTokenType isNil ifTrue: [ self nextToken ].
    ^ currentTokenType
!

currentTokenTypeIs: tokenType
    "if the type is read"
    self halt: 'deprecated'.
    currentTokenType isNil ifFalse: [ ^ currentTokenType = tokenType ].
    
    "if not, try to read the token"
    ^ self perform: tokenType.
!

currentTokenValue
    currentTokenType isNil ifTrue: [ self nextToken ].
    ^ currentTokenType
!

nextToken
    self shouldBeImplemented 
!

parseOn: aPPContext
    | retval |

    context := aPPContext.
    context compiledParser: self.
    failure := PPFailure new message: nil; context: context; position: -1.
    context noteFailure: failure.
    error := false.
    currentTokenType := nil.
    scanner := PPCScanner new.

    self consumeWhitespace.
    retval := self perform: startSymbol.
"	self consumeWhitespace."

    (retval isPetitFailure) ifTrue: [ aPPContext noteFailure: failure ].
    error ifTrue: [ aPPContext noteFailure: failure. retval := failure ].
    
"	aPPContext position: context position."
    ^ retval
! !

